#!/bin/bash
##########################################################################
#                                                                        #
# Installation script for wap4mail                                       #
#                                                                        #
##########################################################################

echo "Specify the directory where you unpacked and will run the software"
instdir="$PWD"
echo -n "[Default $PWD]:"
read usdir
if [ -e "$usdir" ]
then
  instdir=$usdir;
fi
sw_file="$instdir/dataenv.obj"
unique_id=`date +%Y%m%d%h%m%s`.$$;
sw_file_tmp=$sw_file.$unique_id.tmp

failed_string="Installation Failed."
ok_string="Installation Succeed.";

# Check if sw_file exists.
if [ ! -e "$sw_file" ]
then
  echo "$sw_file does not exist."
  echo "$failed_string"
  exit -1
fi

echo "Enter spool dir (where session info is stored):"
echo -n "[Default /var/spool/wap4mail]:"
read spool_dir
if [ "$spool_dir" == "" ]
then
  spool_dir="/var/spool/wap4mail"
fi
# Check if dir exists.
if [ ! -e "$spool_dir" ]
then
  mkdir $spool_dir
fi

echo "Enter proper spool dir owner.group:"
echo -n "[Default www-data.www-data]:"
read spool_ug
if [ "$spool_ug" == "" ]
then
  spool_ug="www-data.www-data"
fi
chown -R $spool_ug $spool_dir

eval sed 's%.*var.*data_area.*%\ \ var\ \$data_area\ =\ \"$spool_dir\"\;%' $sw_file > $sw_file_tmp
mv "$sw_file_tmp" "$sw_file";

# Generate The Random string for $spool_dir/cryptable
MAXCOUNT=511
count=1
RANGE=16

while [ "$count" -le $MAXCOUNT ]  # Generate ($MAXCOUNT) random integers.
do
  number=$RANDOM
  let "number %= $RANGE"
  if [ $number == 10 ]
  then
    number=a
  fi
  if [ $number == 11 ]
  then
    number=b
  fi
  if [ $number == 12 ]
  then
    number=c
  fi
  if [ $number == 13 ]
  then
    number=d
  fi
  if [ $number == 14 ]
  then
    number=e
  fi
  if [ $number == 15 ]
  then
    number=f
  fi
  let "count += 1"  # Increment count.
  cryptable=$cryptable$number;
done

echo $cryptable > $spool_dir/cryptable;
echo "$ok_string";
echo "You must now manually add the following two lines to your /etc/crontab file:"
echo "0  */2   * * *  root  /usr/bin/find $spool_dir/HASH/* -type l -mmin +120 -prune -exec rm -r {} \;"
echo "0  */2   * * *  root /usr/bin/find $spool_dir/pf-*/2* -type d -mmin +120 -prune -exec rm -r {} \;"

exit 0

